local api = require "eu07.events"

local startvehicles = {}
local trackstate = {}

function check_solution()
	if trackstate["iso_lok"][startvehicles["iso_lok"]]
		and trackstate["iso_wag1"][startvehicles["iso_wag2"]]
		and trackstate["iso_wag2"][startvehicles["iso_wag1"]] then
		api.event_dispatch_n("mission_success", nil, 0)
	end
end

local handler = api.event_preparefunc(function(event, activator)
	local split = string.gmatch(api.event_getname(event), "[%a%d_]+")
	local track = split()
	local action = split()
	local id = tostring(activator)

	if startvehicles[track] == nil then
		startvehicles[track] = id
		api.writelog("starting position: "..track..": "..id)
	end

	local val = (action == "inc" and 1 or -1)
	local axles = (trackstate[track][id] or 0) + val
	local out = (axles > 0 and axles or nil)

	api.writelog("track state: "..track..", "..id..": "..axles)
	trackstate[track][id] = out
	check_solution()
end)

local tracks = { "iso_lok", "iso_wag1", "iso_wag2" }

for i = 1, #tracks do
	local track = tracks[i]
	trackstate[track] = { }
	api.event_create(track..":inc", 0, 0, handler)
	api.event_create(track..":dec", 0, 0, handler)
end

api.event_create("iso_bridge:inc", 0, 0, function(event, activator)
	local id = tostring(activator)

	if id == startvehicles["iso_wag1"] or id == startvehicles["iso_wag2"] then
		api.dynobj_putvalues(activator, { str="SetDamage", num1=128, num2=1 })
		api.event_dispatch_n("mission_failed", nil, 0)
	end
end)
